classdef ENHAnCE_software_exported < matlab.apps.AppBase

    % Properties that correspond to app components
    properties (Access = public)
        UIFigure                     matlab.ui.Figure
        ENHAnCEDEMONSTRATORLabel     matlab.ui.control.Label
        MaterialpropertiesLabel      matlab.ui.control.Label
        YoungModulusE70GPaLabel      matlab.ui.control.Label
        PoissonRatiov033Label        matlab.ui.control.Label
        Thickness1mmLabel            matlab.ui.control.Label
        TypealuminiumLabel           matlab.ui.control.Label
        SourcedescriptionLabel       matlab.ui.control.Label
        DescriptionTextAreaLabel     matlab.ui.control.Label
        DescriptionTextArea          matlab.ui.control.TextArea
        TimedomainsignalCheckBox     matlab.ui.control.CheckBox
        SourcespectrumCheckBox       matlab.ui.control.CheckBox
        UIAxes                       matlab.ui.control.UIAxes
        PropagativeguidedmodesLabel  matlab.ui.control.Label
        FrequencyEditFieldLabel      matlab.ui.control.Label
        FrequencyEditField           matlab.ui.control.NumericEditField
        ModesButtonGroup             matlab.ui.container.ButtonGroup
        A0Button                     matlab.ui.control.ToggleButton
        SH0Button                    matlab.ui.control.ToggleButton
        S0Button                     matlab.ui.control.ToggleButton
        MHz0411MHzLabel              matlab.ui.control.Label
        FieldrepresentationLabel     matlab.ui.control.Label
        Sourcelocation00Label        matlab.ui.control.Label
        ReceiverpositionLabel        matlab.ui.control.Label
        xEditFieldLabel              matlab.ui.control.Label
        xEditField                   matlab.ui.control.NumericEditField
        UIAxes2                      matlab.ui.control.UIAxes
        componentsU_iButtonGroup_2   matlab.ui.container.ButtonGroup
        XButton_2                    matlab.ui.control.ToggleButton
        YButton_2                    matlab.ui.control.ToggleButton
        ZButton_2                    matlab.ui.control.ToggleButton
        StartButton                  matlab.ui.control.Button
        MessagesEditFieldLabel       matlab.ui.control.Label
        MessagesEditField            matlab.ui.control.EditField
        Lamp                         matlab.ui.control.Lamp
        A0CheckBox                   matlab.ui.control.CheckBox
        SH0CheckBox                  matlab.ui.control.CheckBox
        y0Label                      matlab.ui.control.Label
        S0CheckBox                   matlab.ui.control.CheckBox
        ModalcontributionLabel       matlab.ui.control.Label
        Density271gcm3Label          matlab.ui.control.Label
    end

    % Callbacks that handle component events
    methods (Access = private)

        % Callback function: A0CheckBox, FrequencyEditField, 
        % ModesButtonGroup, S0CheckBox, SH0CheckBox, 
        % SourcespectrumCheckBox, StartButton, 
        % TimedomainsignalCheckBox, componentsU_iButtonGroup_2, 
        % componentsU_iButtonGroup_2, xEditField
        function StartButtonPushed(app, event)
            
            %initialisation du script avec cet bouton.
            addpath("signal_lib");
            
            
            %-->source description fentre  
            %Utilisation du logiciel dispersive pour les vitesses de groupe 
            epsilon=0.20;
            vmin=1.20-epsilon;     % mm/s
            vmax=5.34+epsilon;     % mm/s
            
            dmax=1000;             % mm         % A fixer
            Tmax=dmax/vmin;        % s
            % Tmin=dmax/(vmax)     % s
            
            %%=============================
            hf=1/Tmax ;            % hf=1/tmax pour la synthse temporelle MHz 
                          
            % Paramtres du signal
            f0 = 0.25 ;            % Frquence centrale en Mz de la source
            T=1/f0    ;            % priode S
            nb_cycles = 3;        % Nombre de cycles
            Fe=2;                 % Frquence d'chantillonnage en MHz 
            
                       
            
            %%=============Importation signal vahan=======================
            % addpath('signal_lib');
            
            % Structure_excitation_temporelle = signal_temporel_hanning(nb_cycles,Fe,f0,0,Tmax,'true');
            
            bpfrel = 0.01*50*f0;                  %Rglage de la largeur de la bande passante 
            Structure_excitation_temporelle =signal_temporel_gaussien(bpfrel,Fe,f0,0,Tmax,'true');
            
                %-->rcupration du signal temporel 
                yt_cut= Structure_excitation_temporelle.signal; 
                t_cut= Structure_excitation_temporelle.temps;
                
                yf_utile=Structure_excitation_temporelle.spectre;
                bpf_utile=Structure_excitation_temporelle.frequence;
                
            
                %--> si time domain signal est activ 
                    app.TimedomainsignalCheckBox.Value
                    if (app.TimedomainsignalCheckBox.Value)
                          close all;
                          plot(t_cut,yt_cut);
                          xlabel("time (\mu s)");
                          ylabel("displacement");
                          app.TimedomainsignalCheckBox.Value=0;
                    end
                     %--> si frequency domain signal est activ 
                      
                    if (app.SourcespectrumCheckBox.Value)
                          close all;
                          plot(bpf_utile, abs(yf_utile)); 
                          xlabel("frequency (MHz)");
                          ylabel("|A(\omega)|");
                          app.SourcespectrumCheckBox.Value=0;
                    end
                    
                
                 
                
                %--> Rchantillonnage sur toutes la dure temporelle du
                %signal
                    
                    idf_utile=Structure_excitation_temporelle.idf_util;
                    
                    nb_ech    = length(yt_cut);
                    tmaxExc   = max(Structure_excitation_temporelle.temps);
                
                %->rgle de 3 pour avoir le nombre d'lments sur la fentre totale de simulation
                    nb_ech_new = round((nb_ech - 1)* Tmax/tmaxExc + 1);
                    
                    %conservation du pas en temps initiale 
                    pas_temps = 1/Fe; 
                    pas_frequence_new = 1/(nb_ech_new*pas_temps);
                    
                    temps_initial = linspace(0,tmaxExc,nb_ech);
                    valeurs       = yt_cut;                                       % On rcupre la partie utile du signal temporelle
                    
                                    
                    % Spectre de l'excitation sur le nouveau nombre de points de l'excitation
                    % jusqu'a Tmax
                    
                    spectre_excitation = ifft(valeurs,nb_ech_new);          %ifft pour toi     (on a fait du zeros padding)
                    % plot(abs(spectre_excitation))
                    
                    frequence          = linspace (0,(nb_ech_new-1)*pas_frequence_new,nb_ech_new);
                    % calcule du spectre normalise
                    module_spectre     = abs(spectre_excitation)/max(abs(spectre_excitation));
                    
                    % recherche des bornes definissant la BP definie par la valeur de seuil passee en argument d'entree de la fonction
                    ind_bp     = find( module_spectre(1:floor(nb_ech_new/2)) >= 0.01); % QUE FREQUENCES POSITIVES
                    
                    fmin_bp    = frequence(ind_bp(1));
                    fmax_bp    = frequence(ind_bp(end));
                    
                    freq_utile=frequence(ind_bp) ;  %frquence utile pour le calcul des modes       
                    
                    
                    %% Importation des modes et visualisation de la dforme dans l'paisseur.
                    if (app.FrequencyEditField.Value~=0)
                         frequency_user=app.FrequencyEditField.Value; 
                         
                         % Trouver les indices suprieurs et infrieurs
                            if (frequency_user<=freq_utile(1) || frequency_user>=freq_utile(length(freq_utile)))
                                 app.MessagesEditField.Value= 'Parameter not allowed';
                                 app.Lamp.Color=[1 0 0]; 
                            else 
                                 %remise  zero de l'afficheur 
                                 app.MessagesEditField.Value= '';
                                 app.Lamp.Color=[0 1 0]; 
                                 
                                 %rcupration de l'indice la frquence 
                                 ind_frequence_user=find(freq_utile>=frequency_user,1); 
                                 frequence_safe_user=freq_utile(ind_frequence_user);    %->la frquence SAFE la plus proche.
                                 
                                 %Importation de la dforme dans l'paisseur
%                                     addpath("\Guide_waves_simulation_tool\ModeITN")
                                    nameModeFolder="ModeITN\M"; 
                                    z=linspace(-1,1,15);
                                    
                                    %->slection du mode
                                    if app.A0Button.Value
                                        k=1;    %numro du mode
                                          
                                    elseif app.SH0Button.Value
                                        k=2;    %numro du mode
                                       
                                    else app.S0Button.Value
                                         k=3;   %numro du mode
                                    end
                                    
                                    namefile=nameModeFolder+num2str(ind_frequence_user-1)+"\M1_evs_"+num2str(k)+"Values.txt";
                                     
                                     evsk= readFile(namefile);
                                    plot(app.UIAxes, evsk(:,1),z,evsk(:,2),z,evsk(:,3),z)  ;  
                                
                            end
                    end
                    
                    
                    
                    addpath("signal_lib");
                    
                       %%-----> Synthse temporelle au point d'valuation M 
                    
                    %rcupration des coordonnes du point 
                    x=app.xEditField.Value;
                    y=0;
                    
                    M=[x,0,0]; 
                    P=[0,0,0];
                    
                    if (x==0 && y==0)    %bloc initial 
                    
                    %importation  nouveau des paramtres du bloc prcdent
                    else 
                            
                            %dbut du procssus
                            if (x<=0 || x<100 || x>dmax)
                                app.MessagesEditField.Value= 'Out of validation region ';
                                app.Lamp.Color=[1 0 0]; 
                                
                            else    %la condition de champ lointain est vrifie  
                                       app.MessagesEditField.Value= 'Running ...';
                                       pause(2)
                                       app.Lamp.Color=[1 0 0]; 
                                       
                                       %->slection des composantes 
                                       m_selection=[app.XButton_2.Value, app.YButton_2.Value, app.ZButton_2.Value]; 
                                       m=find(m_selection);
                                       
                                       
                                        %->Slection des modes  afficher 
                                        
                                        tampon_mode=[app.A0CheckBox.Value app.SH0CheckBox.Value  app.S0CheckBox.Value];
                                        mode_selection=find(tampon_mode); 
                                        vectorFreqData=zeros(1,length(module_spectre)); 
                                        
                                        %->Boucle sur les modes 
                                          for k=1:3      %bloc pour la slection des modes 
                                                app.MessagesEditField.Value= 'Running ...';
                                                pause(2)
                                                app.Lamp.Color=[1 0 0]; 
                             
                                                mode_contribution_signal=zeros(length(freq_utile),3); 
%                                                 vectorTemps=zeros(length(freq_utile),3); %pour le signal temporelle.
                                                
                                                 %Importation de la dforme dans l'paisseur
                                                     nameModeFolder="ModeITN\M"; 
                                                
                                                  %loading of the modal shape at the evaluation point 
                                                 namefile=nameModeFolder+num2str(0)+"\M1_evs_"+num2str(k)+"Values.txt";      
                                                 % avec l'approximation que A(\omega,xi) U_k(\omega,xi) est  indpendant de la frquence 
                                                 evs=readFile(namefile);
                                                 
                                                 %Extraction du vecteur associ au point r(x,y,z) 
                                                  nz=14;                                           %position de la surface 
                                                  Uk=evs(nz,:);
                                                
                                                                                                        
                                                for p=1:length(freq_utile)             %Indice of the frequency    (on  va boucler sur les frquences)
                                                       
                                                    tampon = load(nameModeFolder+num2str(p-1)+"\M1_betas_"+num2str(k)+".txt");
                                                    betak=tampon(1);   %Importation des nombres d'ondes
                                                     
                                                    m=1;   %composantes 
                                                    mode_contribution_signal(p,k) = mode_contribution_signal(p,k)+ farfield(M,P,betak,Uk,m);
                                                    vectorFreqData(ind_bp (p),k)=spectre_excitation(ind_bp(p)).*mode_contribution_signal(p,k);
                                    
                                                end
                                                  vectorTemps(:,k)=fft(vectorFreqData(:,k));      
                         
                                          end
                                          
                                           signal_total=zeros(1,size(vectorTemps,1));
                                           
                                           %->recupration des modes slectionns
                                         
                                           
                                           for k=mode_selection
                                     
                                            signal_total=signal_total+vectorTemps(:,k);
              
                                           end
                                            plot(app.UIAxes2,real( signal_total(:,3))) 
%                                           
                                           app.Lamp.Color=[0 1 0]; 
                                           app.MessagesEditField.Value= ' ';
                                        
%                                        
                                       
                                
                            end  
                            
                  end
                               
                
         
            
        end
    end

    % Component initialization
    methods (Access = private)

        % Create UIFigure and components
        function createComponents(app)

            % Create UIFigure and hide until all components are created
            app.UIFigure = uifigure('Visible', 'off');
            app.UIFigure.Position = [100 100 1068 709];
            app.UIFigure.Name = 'UI Figure';

            % Create ENHAnCEDEMONSTRATORLabel
            app.ENHAnCEDEMONSTRATORLabel = uilabel(app.UIFigure);
            app.ENHAnCEDEMONSTRATORLabel.BackgroundColor = [0.9294 0.6941 0.1255];
            app.ENHAnCEDEMONSTRATORLabel.FontSize = 16;
            app.ENHAnCEDEMONSTRATORLabel.FontColor = [1 1 1];
            app.ENHAnCEDEMONSTRATORLabel.Position = [14 666 226 22];
            app.ENHAnCEDEMONSTRATORLabel.Text = 'ENHAnCE DEMONSTRATOR ';

            % Create MaterialpropertiesLabel
            app.MaterialpropertiesLabel = uilabel(app.UIFigure);
            app.MaterialpropertiesLabel.BackgroundColor = [0.851 0.3255 0.098];
            app.MaterialpropertiesLabel.FontSize = 16;
            app.MaterialpropertiesLabel.FontWeight = 'bold';
            app.MaterialpropertiesLabel.Position = [18 578 148 22];
            app.MaterialpropertiesLabel.Text = 'Material properties';

            % Create YoungModulusE70GPaLabel
            app.YoungModulusE70GPaLabel = uilabel(app.UIFigure);
            app.YoungModulusE70GPaLabel.FontSize = 16;
            app.YoungModulusE70GPaLabel.FontWeight = 'bold';
            app.YoungModulusE70GPaLabel.Position = [18 496 220 22];
            app.YoungModulusE70GPaLabel.Text = 'Young Modulus (E): 70 GPa ';

            % Create PoissonRatiov033Label
            app.PoissonRatiov033Label = uilabel(app.UIFigure);
            app.PoissonRatiov033Label.FontSize = 16;
            app.PoissonRatiov033Label.FontWeight = 'bold';
            app.PoissonRatiov033Label.Position = [18 475 186 22];
            app.PoissonRatiov033Label.Text = 'Poisson Ratio   (v): 0.33';

            % Create Thickness1mmLabel
            app.Thickness1mmLabel = uilabel(app.UIFigure);
            app.Thickness1mmLabel.FontSize = 16;
            app.Thickness1mmLabel.FontWeight = 'bold';
            app.Thickness1mmLabel.Position = [14 429 136 22];
            app.Thickness1mmLabel.Text = 'Thickness: 1 mm';

            % Create TypealuminiumLabel
            app.TypealuminiumLabel = uilabel(app.UIFigure);
            app.TypealuminiumLabel.FontSize = 16;
            app.TypealuminiumLabel.FontWeight = 'bold';
            app.TypealuminiumLabel.Position = [14 532 136 22];
            app.TypealuminiumLabel.Text = ' Type: aluminium';

            % Create SourcedescriptionLabel
            app.SourcedescriptionLabel = uilabel(app.UIFigure);
            app.SourcedescriptionLabel.BackgroundColor = [0.851 0.3255 0.098];
            app.SourcedescriptionLabel.FontSize = 16;
            app.SourcedescriptionLabel.FontWeight = 'bold';
            app.SourcedescriptionLabel.Position = [349 578 154 22];
            app.SourcedescriptionLabel.Text = 'Source description ';

            % Create DescriptionTextAreaLabel
            app.DescriptionTextAreaLabel = uilabel(app.UIFigure);
            app.DescriptionTextAreaLabel.HorizontalAlignment = 'right';
            app.DescriptionTextAreaLabel.FontSize = 16;
            app.DescriptionTextAreaLabel.FontWeight = 'bold';
            app.DescriptionTextAreaLabel.Position = [338 532 93 22];
            app.DescriptionTextAreaLabel.Text = 'Description';

            % Create DescriptionTextArea
            app.DescriptionTextArea = uitextarea(app.UIFigure);
            app.DescriptionTextArea.FontSize = 14;
            app.DescriptionTextArea.Position = [447 495 134 57];
            app.DescriptionTextArea.Value = {'Three sinusoidal cycles with a central frequency of 100 kHz'; 'Time windowing: Gaussian'};

            % Create TimedomainsignalCheckBox
            app.TimedomainsignalCheckBox = uicheckbox(app.UIFigure);
            app.TimedomainsignalCheckBox.ValueChangedFcn = createCallbackFcn(app, @StartButtonPushed, true);
            app.TimedomainsignalCheckBox.Text = 'Time domain signal';
            app.TimedomainsignalCheckBox.FontSize = 16;
            app.TimedomainsignalCheckBox.Position = [349 460 160 22];

            % Create SourcespectrumCheckBox
            app.SourcespectrumCheckBox = uicheckbox(app.UIFigure);
            app.SourcespectrumCheckBox.ValueChangedFcn = createCallbackFcn(app, @StartButtonPushed, true);
            app.SourcespectrumCheckBox.Text = 'Source spectrum';
            app.SourcespectrumCheckBox.FontSize = 16;
            app.SourcespectrumCheckBox.Position = [349 429 143 22];

            % Create UIAxes
            app.UIAxes = uiaxes(app.UIFigure);
            title(app.UIAxes, 'Displacement components ')
            xlabel(app.UIAxes, '')
            ylabel(app.UIAxes, 'Z')
            app.UIAxes.FontSize = 16;
            app.UIAxes.Position = [646 311 274 186];

            % Create PropagativeguidedmodesLabel
            app.PropagativeguidedmodesLabel = uilabel(app.UIFigure);
            app.PropagativeguidedmodesLabel.BackgroundColor = [0.851 0.3255 0.098];
            app.PropagativeguidedmodesLabel.FontSize = 16;
            app.PropagativeguidedmodesLabel.FontWeight = 'bold';
            app.PropagativeguidedmodesLabel.Position = [690 578 210 22];
            app.PropagativeguidedmodesLabel.Text = 'Propagative guided modes';

            % Create FrequencyEditFieldLabel
            app.FrequencyEditFieldLabel = uilabel(app.UIFigure);
            app.FrequencyEditFieldLabel.HorizontalAlignment = 'right';
            app.FrequencyEditFieldLabel.FontSize = 16;
            app.FrequencyEditFieldLabel.FontWeight = 'bold';
            app.FrequencyEditFieldLabel.Position = [698 532 86 22];
            app.FrequencyEditFieldLabel.Text = 'Frequency';

            % Create FrequencyEditField
            app.FrequencyEditField = uieditfield(app.UIFigure, 'numeric');
            app.FrequencyEditField.ValueChangedFcn = createCallbackFcn(app, @StartButtonPushed, true);
            app.FrequencyEditField.Position = [799 532 40 22];

            % Create ModesButtonGroup
            app.ModesButtonGroup = uibuttongroup(app.UIFigure);
            app.ModesButtonGroup.SelectionChangedFcn = createCallbackFcn(app, @StartButtonPushed, true);
            app.ModesButtonGroup.TitlePosition = 'centertop';
            app.ModesButtonGroup.Title = 'Modes';
            app.ModesButtonGroup.FontWeight = 'bold';
            app.ModesButtonGroup.FontSize = 16;
            app.ModesButtonGroup.Position = [940 371 100 111];

            % Create A0Button
            app.A0Button = uitogglebutton(app.ModesButtonGroup);
            app.A0Button.Text = 'A0';
            app.A0Button.Position = [22 58 57 22];
            app.A0Button.Value = true;

            % Create SH0Button
            app.SH0Button = uitogglebutton(app.ModesButtonGroup);
            app.SH0Button.Text = 'SH0';
            app.SH0Button.Position = [22 36 57 22];

            % Create S0Button
            app.S0Button = uitogglebutton(app.ModesButtonGroup);
            app.S0Button.Text = 'S0';
            app.S0Button.Position = [23 12 57 22];

            % Create MHz0411MHzLabel
            app.MHz0411MHzLabel = uilabel(app.UIFigure);
            app.MHz0411MHzLabel.FontSize = 16;
            app.MHz0411MHzLabel.Position = [866 532 175 22];
            app.MHz0411MHzLabel.Text = '(0.08 MHz - 0.411 MHz)';

            % Create FieldrepresentationLabel
            app.FieldrepresentationLabel = uilabel(app.UIFigure);
            app.FieldrepresentationLabel.BackgroundColor = [0.851 0.3255 0.098];
            app.FieldrepresentationLabel.FontSize = 16;
            app.FieldrepresentationLabel.FontWeight = 'bold';
            app.FieldrepresentationLabel.Position = [30 371 163 22];
            app.FieldrepresentationLabel.Text = 'Field representation ';

            % Create Sourcelocation00Label
            app.Sourcelocation00Label = uilabel(app.UIFigure);
            app.Sourcelocation00Label.FontSize = 16;
            app.Sourcelocation00Label.FontWeight = 'bold';
            app.Sourcelocation00Label.Position = [19 341 169 22];
            app.Sourcelocation00Label.Text = 'Source location: (0 0)';

            % Create ReceiverpositionLabel
            app.ReceiverpositionLabel = uilabel(app.UIFigure);
            app.ReceiverpositionLabel.FontSize = 16;
            app.ReceiverpositionLabel.FontWeight = 'bold';
            app.ReceiverpositionLabel.Position = [235 341 148 22];
            app.ReceiverpositionLabel.Text = 'Receiver position: ';

            % Create xEditFieldLabel
            app.xEditFieldLabel = uilabel(app.UIFigure);
            app.xEditFieldLabel.HorizontalAlignment = 'right';
            app.xEditFieldLabel.FontSize = 14;
            app.xEditFieldLabel.FontWeight = 'bold';
            app.xEditFieldLabel.Position = [388 342 25 22];
            app.xEditFieldLabel.Text = 'x';

            % Create xEditField
            app.xEditField = uieditfield(app.UIFigure, 'numeric');
            app.xEditField.ValueChangedFcn = createCallbackFcn(app, @StartButtonPushed, true);
            app.xEditField.Position = [428 342 55 22];

            % Create UIAxes2
            app.UIAxes2 = uiaxes(app.UIFigure);
            title(app.UIAxes2, 'guided waves signal processing')
            xlabel(app.UIAxes2, 'Time (\mus) ')
            ylabel(app.UIAxes2, 'U_i')
            app.UIAxes2.FontSize = 14;
            app.UIAxes2.FontWeight = 'bold';
            app.UIAxes2.Position = [36 30 551 199];

            % Create componentsU_iButtonGroup_2
            app.componentsU_iButtonGroup_2 = uibuttongroup(app.UIFigure);
            app.componentsU_iButtonGroup_2.SelectionChangedFcn = createCallbackFcn(app, @StartButtonPushed, true);
            app.componentsU_iButtonGroup_2.TitlePosition = 'centertop';
            app.componentsU_iButtonGroup_2.Title = 'components U_i ';
            app.componentsU_iButtonGroup_2.SizeChangedFcn = createCallbackFcn(app, @StartButtonPushed, true);
            app.componentsU_iButtonGroup_2.FontWeight = 'bold';
            app.componentsU_iButtonGroup_2.FontSize = 16;
            app.componentsU_iButtonGroup_2.Position = [8 241 193 71];

            % Create XButton_2
            app.XButton_2 = uitogglebutton(app.componentsU_iButtonGroup_2);
            app.XButton_2.Text = 'X';
            app.XButton_2.Position = [11 12 57 22];

            % Create YButton_2
            app.YButton_2 = uitogglebutton(app.componentsU_iButtonGroup_2);
            app.YButton_2.Text = 'Y';
            app.YButton_2.Position = [68 12 57 22];

            % Create ZButton_2
            app.ZButton_2 = uitogglebutton(app.componentsU_iButtonGroup_2);
            app.ZButton_2.Text = 'Z';
            app.ZButton_2.Position = [124 12 57 22];
            app.ZButton_2.Value = true;

            % Create StartButton
            app.StartButton = uibutton(app.UIFigure, 'push');
            app.StartButton.ButtonPushedFcn = createCallbackFcn(app, @StartButtonPushed, true);
            app.StartButton.FontSize = 20;
            app.StartButton.Position = [36 621 100 31];
            app.StartButton.Text = 'Start';

            % Create MessagesEditFieldLabel
            app.MessagesEditFieldLabel = uilabel(app.UIFigure);
            app.MessagesEditFieldLabel.HorizontalAlignment = 'right';
            app.MessagesEditFieldLabel.FontWeight = 'bold';
            app.MessagesEditFieldLabel.Position = [724 119 98 22];
            app.MessagesEditFieldLabel.Text = 'Messages';

            % Create MessagesEditField
            app.MessagesEditField = uieditfield(app.UIFigure, 'text');
            app.MessagesEditField.Position = [830 119 201 22];

            % Create Lamp
            app.Lamp = uilamp(app.UIFigure);
            app.Lamp.Position = [1049 120 20 20];

            % Create A0CheckBox
            app.A0CheckBox = uicheckbox(app.UIFigure);
            app.A0CheckBox.ValueChangedFcn = createCallbackFcn(app, @StartButtonPushed, true);
            app.A0CheckBox.Text = 'A0';
            app.A0CheckBox.FontSize = 16;
            app.A0CheckBox.Position = [258 253 41 22];
            app.A0CheckBox.Value = true;

            % Create SH0CheckBox
            app.SH0CheckBox = uicheckbox(app.UIFigure);
            app.SH0CheckBox.ValueChangedFcn = createCallbackFcn(app, @StartButtonPushed, true);
            app.SH0CheckBox.Text = 'SH0';
            app.SH0CheckBox.FontSize = 16;
            app.SH0CheckBox.Position = [314 253 53 22];
            app.SH0CheckBox.Value = true;

            % Create S0CheckBox
            app.S0CheckBox = uicheckbox(app.UIFigure);
            app.S0CheckBox.ValueChangedFcn = createCallbackFcn(app, @StartButtonPushed, true);
            app.S0CheckBox.Text = 'S0';
            app.S0CheckBox.FontSize = 16;
            app.S0CheckBox.Position = [383 253 41 22];
            app.S0CheckBox.Value = true;

            % Create ModalcontributionLabel
            app.ModalcontributionLabel = uilabel(app.UIFigure);
            app.ModalcontributionLabel.FontSize = 18;
            app.ModalcontributionLabel.FontWeight = 'bold';
            app.ModalcontributionLabel.Position = [258 289 168 23];
            app.ModalcontributionLabel.Text = 'Modal contribution';

            % Create y0Label
            app.y0Label = uilabel(app.UIFigure);
            app.y0Label.FontSize = 14;
            app.y0Label.FontWeight = 'bold';
            app.y0Label.Position = [508 341 56 22];
            app.y0Label.Text = ' y        0';

            % Create Density271gcm3Label
            app.Density271gcm3Label = uilabel(app.UIFigure);
            app.Density271gcm3Label.FontSize = 16;
            app.Density271gcm3Label.FontWeight = 'bold';
            app.Density271gcm3Label.Position = [18 454 155 22];
            app.Density271gcm3Label.Text = 'Density: 2.71 g/cm3';

            % Show the figure after all components are created
            app.UIFigure.Visible = 'on';
        end
    end

    % App creation and deletion
    methods (Access = public)

        % Construct app
        function app = ENHAnCE_software_exported

            % Create UIFigure and components
            createComponents(app)

            % Register the app with App Designer
            registerApp(app, app.UIFigure)

            if nargout == 0
                clear app
            end
        end

        % Code that executes before app deletion
        function delete(app)

            % Delete UIFigure when app is deleted
            delete(app.UIFigure)
        end
    end
end