
function Structure_excitation_temporelle = signal_temporel_gaussien(bpfrel,fe,fmod,eta,Tmax,opt_display)

%--> Echantillonnage en temps
dt = 1/fe;

%--> Parametres de la gaussienne en temps
Vart = log(4)/pi^2/bpfrel^2;

%--> Discretisation en temps
t = 0:dt:Tmax;

%--> Construction de la gaussienne en temps
y0 = exp(-(t.*t)/(2*Vart));
tc = find(y0<1e-8, 1 )*dt;
t  = 0:dt:4*tc;

y1 = exp(-(t-tc).*(t-tc)/(2*Vart));
y2 = sin(2*pi*fmod*t);
y3 = exp(-eta*t);
yt = y1.*y2.*y3;
% 
% %--> Affichage du signal
% if opt_display
%    figure
%    plot(t,yt)
% end

%--> Transformee de Fourier du signal temporel 
yf = fft(yt);
nb_pt_f  = length(yf);

%--> Discretisation en frequence
f = (0:nb_pt_f-1)*fe/nb_pt_f;

%--> Extraction de la moitie du spectre en frequence
fcut=f(1:round(nb_pt_f/2));

yf_normalise = yf/max(abs(yf));

yfcut = yf_normalise(1:round(nb_pt_f/2));

% if opt_display
%    figure
%    plot(fcut,abs(yfcut));
% end

%--> Seuil a partir duquel le signal est considere comme nul
seuil = 0.01;

%--> Recuperation de la bande passante utile
Indice_calcul_frequentiel = find(abs(yfcut)>seuil);
%Imin = min(I);
%Imax = max(I);

yf_utile  = yfcut;
bpf_utile = fcut;

yt_cut = yt(1:round(nb_pt_f/2));
t_cut  =  t(1:round(nb_pt_f/2));

f = bpf_utile(Indice_calcul_frequentiel);

Structure_excitation_temporelle.spectre   = yf_utile;
Structure_excitation_temporelle.frequence = bpf_utile;
Structure_excitation_temporelle.bp_fu     = f;
Structure_excitation_temporelle.idf_util  = Indice_calcul_frequentiel;
Structure_excitation_temporelle.fc        = fmod;

Structure_excitation_temporelle.signal = yt_cut;
Structure_excitation_temporelle.temps  = t_cut;



